Unit zf20e_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, UTZF11_p;

procedure zf20e(F :Func_F1E; A :Extended; B :Extended; EPS :Extended;
                var ROOT :Extended; ITMAX :Integer; var IERR :Integer);

implementation

procedure zf20e(F :Func_F1E; A :Extended; B :Extended; EPS :Extended;
                var ROOT :Extended; ITMAX :Integer; var IERR :Integer);
var
J :Integer;
FL,FH,XL,XH,SWAP,DX,FR,DEL :Extended;
const
ZERO :Extended = 0.0e0;
label
_10,_20,_30,_40,_50,_60,_70,_80;
begin
IERR := 0;
FL := F(A);
FH := F(B);
if ( FL*FH <= ZERO ) 
 then goto _10;
IERR := 66;
goto _70;
_10:
if ( FL >= ZERO ) 
 then goto _20;
XL := A;
XH := B;
goto _30;
_20:
XL := B;
XH := A;
SWAP := FL;
FL := FH;
FH := SWAP;
_30:
DX := XH-XL;
for J:=1 to ITMAX do
 begin
  _ZF20RR.elm1:= J;
  ROOT := XL+DX*FL/(FL-FH);
  FR := F(ROOT);
  if ( FR >= ZERO ) 
   then goto _40;
  DEL := XL-ROOT;
  XL := ROOT;
  FL := FR;
  goto _50;
_40:
  DEL := XH-ROOT;
  XH := ROOT;
  FH := FR;
_50:
  DX := XH-XL;
  if ( Abs(DEL) < Abs(EPS) ) or ( FR = ZERO ) 
   then goto _80;
_60:
 end;
IERR := 65;
_70:
UTZF11(IERR,20);
_80:
end;

end.
